#pragma once

// Quelle: https://stackoverflow.com/questions/51752284/how-to-calculate-crc8-in-c

#include <cstdint>


// Klasse zur Berechnung einer CRC8-Prfsumme
class CRC8Generator  {
   // Polynoml:  0x07
   // Startwert: 0xFF

public:
   // Paket
   // ---------------------------------------

   // Generiert die CRC8 fr ein Datenpaket.
   uint8_t generateCRC(const uint8_t* data, size_t len);


   // Stream
   // ---------------------------------------

   // Gibt ein Byte an den Datenstrom ab und berechnet dabei fortlaufend die CRC.
   void streamCRC(uint8_t b);

   // Gibt die CRC an den Datenstrom weiter (LSB First) 
   // und initialisiert erneut die internen Variablen.
   uint8_t streamFin();

   // Funktion, die ein Byte an den Datenstrom abgibt.
   void (*executor)(uint8_t b) = dummyExcecutor;

protected:
   // Leere Funktion zur initialisierung der Variable 'executor'.
   static void dummyExcecutor(uint8_t b) {}
   
   // Startwert der CRC-Berechnung.
   const  uint8_t crcSeed = 0xFF;

   // Zwischenspeicher fr die fortlaufende Berechnung.
   uint8_t crc = crcSeed;
};