Module Program
   ReadOnly TestData As Byte() = New Byte() {&H31, &H32, &H33, &H34, &H35, &H36, &H37, &H38, &H39} ' "123456789"
   ReadOnly TestData1 As Byte() = New Byte() {&HE4, &H6D, &H46, &HF8, &HFB, &H16, &HAB, &H52, &HED, &H64, &H50, &H23, &H63, &HD, &H80, &HBC, &H98, &HD8, &H16, &HFF, &HEF, &H3C, &H4E, &HD9, &HBD, &HA1, &H85, &H95, &H13}
   ReadOnly TestData2 As Byte() = New Byte() {&H42, &HDF, &H54, &H99, &H99, &H20, &H98, &HCF, &HF1, &HFC, &HF5, &H9E, &HED, &H36, &H61, &H4A, &HA2, &H31, &HF3, &H3E, &H2, &HB1, &H8A, &H95, &HE5, &HF7, &H88}
   ReadOnly TestData3 As Byte() = New Byte() {&H5B, &HB5, &H6, &H4, &H52, &HDE, &HD8, &HEC, &H13, &H35, &H6B, &H59, &HC8, &H66, &HA4, &HF6, &HC9, &HA8, &H63, &H3, &HB9, &HA8, &HFD, &HD9, &H57}

   ReadOnly crc8Generator As CRC8GeneratorLookUp = New CRC8GeneratorLookUp()
   ReadOnly crc16Generator As CRC16GeneratorLookUp = New CRC16GeneratorLookUp()
   ReadOnly crc32Generator As CRC32GeneratorLookUp = New CRC32GeneratorLookUp()

   Function stream8TestData(data As Byte()) As UInt32
      For i = 0 To data.Length - 1
         crc8Generator.streamCRC(data(i))
      Next
      Return crc8Generator.streamFin()
   End Function

   Function stream16TestData(data As Byte()) As UInt32
      For i = 0 To data.Length - 1
         crc16Generator.streamCRC(data(i))
      Next
      Return crc16Generator.streamFin()
   End Function

   Function stream32TestData(data As Byte()) As UInt32
      For i = 0 To data.Length - 1
         crc32Generator.streamCRC(data(i))
      Next
      Return crc32Generator.streamFin()
   End Function
   Sub Main(args As String())
      Console.WriteLine("VB CRC-Generator Test")

      Console.WriteLine("==========================" & vbCrLf)
      Console.WriteLine("  CRC8")
      Console.WriteLine("==========================")

      Console.WriteLine("  genCRC: " & crc8Generator.genCRC(TestData))
      Console.WriteLine("  stream: " & stream8TestData(TestData))
      Console.WriteLine("--------------------------")
      Console.WriteLine("1 genCRC: " & crc8Generator.genCRC(TestData1))
      Console.WriteLine("  stream: " & stream8TestData(TestData1))
      Console.WriteLine("--------------------------")
      Console.WriteLine("2 genCRC: " & crc8Generator.genCRC(TestData2))
      Console.WriteLine("  stream: " & stream8TestData(TestData2))
      Console.WriteLine("--------------------------")
      Console.WriteLine("3 genCRC: " & crc8Generator.genCRC(TestData3))
      Console.WriteLine("  stream: " & stream8TestData(TestData3))

      Console.WriteLine("==========================" & vbCrLf)
      Console.WriteLine("  CRC16")
      Console.WriteLine("==========================")

      Console.WriteLine("  genCRC: " & crc16Generator.genCRC(TestData))
      Console.WriteLine("  stream: " & stream16TestData(TestData))
      Console.WriteLine("--------------------------")
      Console.WriteLine("1 genCRC: " & crc16Generator.genCRC(TestData1))
      Console.WriteLine("  stream: " & stream16TestData(TestData1))
      Console.WriteLine("--------------------------")
      Console.WriteLine("2 genCRC: " & crc16Generator.genCRC(TestData2))
      Console.WriteLine("  stream: " & stream16TestData(TestData2))
      Console.WriteLine("--------------------------")
      Console.WriteLine("3 genCRC: " & crc16Generator.genCRC(TestData3))
      Console.WriteLine("  stream: " & stream16TestData(TestData3))

      Console.WriteLine("==========================" & vbCrLf)
      Console.WriteLine("  CRC32")
      Console.WriteLine("==========================")

      Console.WriteLine("  genCRC: " & crc32Generator.generateCRC(TestData))
      Console.WriteLine("  stream: " & stream32TestData(TestData))
      Console.WriteLine("--------------------------")
      Console.WriteLine("1 genCRC: " & crc32Generator.generateCRC(TestData1))
      Console.WriteLine("  stream: " & stream32TestData(TestData1))
      Console.WriteLine("--------------------------")
      Console.WriteLine("2 genCRC: " & crc32Generator.generateCRC(TestData2))
      Console.WriteLine("  stream: " & stream32TestData(TestData2))
      Console.WriteLine("--------------------------")
      Console.WriteLine("3 genCRC: " & crc32Generator.generateCRC(TestData3))
      Console.WriteLine("  stream: " & stream32TestData(TestData3))
   End Sub
End Module

' Output ist
' 
'VB CRC-Generator Test
'==========================
'
'  CRC8
'==========================
'  genCRC: 244
'  stream: 244
'--------------------------
'1 genCRC: 133
'  stream: 133
'--------------------------
'2 genCRC: 233
'  stream: 233
'--------------------------
'3 genCRC: 229
'  stream: 229
'==========================
'
'  CRC16
'==========================
'  genCRC: 58828
'  stream: 58828
'--------------------------
'1 genCRC: 39760
'  stream: 39760
'--------------------------
'2 genCRC: 59077
'  stream: 59077
'--------------------------
'3 genCRC: 32278
'  stream: 32278
'==========================
'
'  CRC32
'==========================
'  genCRC: 3421780262
'  stream: 3421780262
'--------------------------
'1 genCRC: 1628163719
'  stream: 1628163719
'--------------------------
'2 genCRC: 2942970280
'  stream: 2942970280
'--------------------------
'3 genCRC: 948803831
'  stream: 948803831